/**
	Definitions for "hola" program
	(this use OpenGL primitives and Qt)

	Fraga 19/09/2001
**/
#ifndef CONO_H
#define CONO_H

#include <QWidget>
#include <QtOpenGL>
#include <QTimer>

class Cono: public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Cono( QWidget *parent=0 );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}
	void creaCono( float v[][3], float lado, float radio );
	void dibujaCono( float v[][3] );

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(500);
	}
	void stop( void ) {
		timer->stop( );
 	} 

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float yrot, xrot;  // Encene rotation

	float angle;
	int signo;
	int xmouse, ymouse;  // Mouse pointer coordinates

	int n;
	float c1[11][3]; // para 8 puntos en la base
};


#endif // CONO_H
